*  TimeStamp  (dos) : 29 Novembre 04 10:39  --  d:\db3\skku.prg
*  calcul de skewness et kurtosis

clear
set talk   off
set safety off


  ?  "skku.prg "
  ?  "                                           Cpy. (gH) Gilles HUNAULT, 1998"
  ?  "                                            gilles.hunault@univ-angers.fr"
  ?

  clear memory

  store dbf() + replicate(" ",20) to nombase
  store substr(nombase,1,20) to nombase
  @ 8,03 say " Nom de la base ? : "
  @ 9,03 say " (ou Aide pour explications)"
  @ 8,50 get nombase
  read

  IF substr(upper(nombase+"    "),1,4) = "AIDE" .OR. len(trim(ltrim(nombase)))=0
     clear
     ? "calcul de skewness et kurtosis"
     ? "                                           Cpy. (gH) Gilles HUNAULT, 1997"
     ? "                                            gilles.hunault@univ-angers.fr"
     ?
     ? " Vous devez disposer d'une base de donnes au sens Dbase"
     ? " (fichier de type .DBF) dont la structure doit tre la suivante :"
     ?
     ? "   - un premier champ de type Caractre de dimension 4"
     ? "   - tous les autres champs sont numriques. "
     ?
     ? " le champ que vous voulez utiliser doit tre de nature QT."
     ?
     RETURN
  ENDIF

  store trim(ltrim(nombase)) to nombase
  IF at(".DBF",upper(nombase)) = 0
    store nombase+".DBF" to NOMComplet
  ELSE
    store nombase        to NOMComplet
    store at(".DBF",upper(nombase)) to ip
    store substr(nombase,1,ip-1) to nombase
  ENDIF


 IF .NOT. FILE(NOMComplet)
   ? chr(7)
   ? chr(7)
   ? " Dsol, je ne vois pas ce fichier. Vrifiez son existence avec DIR "
   ? " Ne tapez pas .DBF mais indiquer le chemin d'accs ( PATH ) "
   ?
   ? " Fin anormale d'excution, code 1 : fichier non trouv."
   ?
   RETURN
 ENDIF

  USE   &NOMComplet
  STORE Nombase+".sku" to Nomsor
  DISP  STRU
  accept "Nom de la variable  traiter ? " to nomVar

  SET   ALTER  TO &Nomsor
  SET   ALTER  ON
  SET   SAFETY OFF
  ?
  ? " Calcul de skewness et kurtosis pour la variable ", nomVar," base ",Nombase
  ?

  ** calcul de la moyenne et de l'cart-type

  AVERAGE &nomVar         TO moy
  AVERAGE &nomVar*&nomvar TO mct
  STORE mct-moy*moy       TO var
  STORE SQRT(var)         TO ect

  ** on base la base de donnes en revue
  ** on calcule au fur et  mesure la valeur centre rduite

  STORE 0 TO s_sk
  STORE 0 TO s_ku
  GOTO 1
  DO WHILE .NOT. EOF()
     STORE &nomVar         TO laval
     STORE (laval-moy)/ect TO cr
     STORE s_sk + cr**3    TO s_sk
     STORE s_ku + cr**4    TO s_ku
     SKIP
  ENDDO
  COUNT TO nbVal
  STORE s_sk/nbVal TO sk
  STORE s_ku/nbVal TO ku

  ? " Nombre de valeur " , nbVal
  ? " Moyenne          " , moy
  ? " Ecart-type       " , ect
  ? " Asymtrie        " , sk
  ? " Aplatissement    " , ku
  ?

  disp memo

?
? " -- fin de skku "
?
close alter
?
? " Rsultats dans ",nomsor
?
set talk   on
set safety on
